;Adobe Helvetica normal
;-------------------------------------------------
;Berechnet den nächsten Punkt einer Linie
;-------------------------------------------------
;The result is the next point of a line
;-------------------------------------------------
;	Code for the best assembler: The Netwide Assembler: NASM
;	Copyright (C) 2004 by Sebastian Beck; sebastian.bw@freenet.de

;	Wenn Sie eine Spende machen wollen, fragen Sie mich ber E-Mail
;	nach meiner Bankverbindung.

;	If you want to make a donation, please question me by e-mail for
;	my banking connection.

;-------------------------------------------------
;%include "./INC/LINIE.inc"
;%include "./INC/linie.inc"
;%include "./INC/outnc-2.7.inc"
;%include "./INC/brechner.inc"

;buf			resb	25
;Deltax		dd	0		;Schritte X
;Deltay		dd	0		;Schritte Y
;Deltaz		dd	0		;Schritte Z
;Linex			dd	0		;Aktueller X-Wert der Linie
;Liney			dd	0		;Aktueller Y-Wert der Linie
;Linez			dd	0		;Aktueller Z-Wert der Linie

;Linedev		db	0		;Liniendefiniton
;	a Z Y X
;Bit	3 2 1 0			X	Y	Z
;	x 0 0 0	nach		+	+	+
;	x 0 0 1	nach		-	+	+
;	x 0 1 0	nach		+	-	+
;	x 0 1 1	nach		-	-	+
;	x 1 0 0	nach		+	+	-
;	x 1 0 1	nach		-	+	-
;	x 1 1 0	nach		+	-	-
;	x 1 1 1	nach		-	-	-
;	0 x x x	relativ zur aktuellen Position
;	1 x x x	absolut zum Werkstücknullpunkt
;-------------------------------------------------

LINIE:
section .text

	mov	eax,3
	mov	ebx,[datnum]
	mov	ecx,buf
	mov	edx,14
	int	80h
	cmp	eax,14
	jz	.a
	call	error1
	jmp	Ende
.a:
	mov	dword[Linex],0
	mov	dword[Liney],0
	mov	dword[Linez],0
	mov	al,[buf]
	test	al,00001000b		;ob relativ
	jnz	.ax1				;wenn 1 = absolut
	jmp	.b
.ax1:						;--- absolut ---
	mov	ecx,1000000000	
	sub	ecx,[X]			;ecx = X_ist
	jc	.ax4
						;--- (+) X_ist ---
	test	al,00000001b
	jz	.ax2				;wenn X_soll = (+)
	add	[buf+1],ecx			;(-) X_soll
	jmp	.ay1				;R(-)  (+ -)

.ax2:						;(+) X_soll
	sub	ecx,[buf+1]			;X_ist - X_soll
	jnc	.ax3
	neg	ecx
	mov	[buf+1], ecx
	jmp	.ay1				;R(+)  (+ +)
.ax3:
	mov	[buf+1],ecx
	or	al,00000001b
	jmp	.ay1				;R(-)  (+ +)

.ax4:						;--- (-) X_ist ---
	neg	ecx
	test	al,00000001b
	jnz	.ax5				;wenn R_soll = 1  (-)
	add	[buf+1],ecx			;R == (+)
	jmp	.ay1				;R (+)  (- +)
	
.ax5:						;R == (-)
	sub	ecx,[buf+1]			;X_ist - X_soll
	jnc	.ax6
	neg	ecx
	mov	[buf+1],ecx
	jmp	.ay1				;R (-)  (- -)
.ax6:
	and	al,11111110b
	mov	[buf+1],ecx			;R (+)  (- -)

.ay1:						;--- absolut ---
	mov	ecx,1000000000	
	sub	ecx,[Y]			;ecx = Y_ist
	jc	.ay4
						;--- (+) Y_ist ---
	test	al,00000010b
	jz	.ay2				;wenn R_soll = 0  (+)
	add	[buf+5],ecx			;R_soll (-)
	jmp	.az1				;R(-)  (+ -)
.ay2:
	sub	ecx,[buf+5]			;Y_ist - Y_soll
	jnc	.ay3
	neg	ecx
	mov	[buf+5], ecx
	jmp	.az1				;R(+)  (+ +)
.ay3:
	mov	[buf+5],ecx
	or	al,00000010b
	jmp	.az1				;R(-)  (+ +)

.ay4:						;--- (-) Y_ist ---
	neg	ecx
	test	al,00000010b
	jnz	.ay5				;wenn R_soll = 1  (-)
	add	[buf+5],ecx			;R == (+)
	jmp	.az1				;R (+)  (- +)
	
.ay5:						;R == (-)
	sub	ecx,[buf+5]			;Y_ist - Y_soll
	jnc	.ay6
	neg	ecx
	mov	[buf+5],ecx
	jmp	.az1				;R (-)  (- -)
.ay6:
	and	al,11111101b
	mov	[buf+5],ecx			;R (+)  (- -)

.az1:						;--- absolut ---
	mov	ecx,1000000000	
	sub	ecx,[Z]			;ecx = Z_ist
	jnc	.az4
						;--- (+) Z_ist ---
	neg	ecx
	test	al,00000100b
	jz	.az2				;wenn R_soll = (+)
	add	[buf+9],ecx			;(-) R_soll
	jmp	.b				;R(-)  (+ -)
.az2:
	sub	ecx,[buf+9]			;Z_ist - Z_soll
	jnc	.az3
	neg	ecx
	mov	[buf+9], ecx
	jmp	.b				;R(+)  (+ +)
.az3:
	mov	[buf+9],ecx
	or	al,00000100b
	jmp	.b				;R(-)  (+ +)

.az4:						;--- (-) Z_ist ---
	test	al,00000100b
	jnz	.az5				;wenn R_soll = 1  (-)
	add	[buf+9],ecx			;R == (+)
	jmp	.b				;R (+)  (- +)
	
.az5:						;R == (-)
	sub	ecx,[buf+9]			;Z_ist - Z_soll
	jnc	.az6
	neg	ecx
	mov	[buf+9],ecx
	jmp	.b				;R (-)  (- -)
.az6:
	and	al,11111011b
	mov	[buf+9],ecx			;R (+)  (- -)

.b:						;--- relativ ---
	mov	[Linedev],al
	mov	eax,[buf+1]
	mov	[Deltax],eax
	mov	edx,eax			;b edx soll das längste Maß enthalten
	mov	ebx,Linex			;b und in ebx den zugehörigen Zeiger
	mov	ebp,Deltax			;b und in ebp den vergleichs Zeiger
	
	mov	eax,[buf+5]
	mov	[Deltay],eax
	cmp	edx,eax
	jae	.b1
	mov	edx,eax			;b speichere in edx das größere Maß
	mov	ebx,Liney			;b und in ebx den zugehörigen Zeiger
	mov	ebp,Deltay			;b und in ebp den vergleichs Zeiger
.b1:
	mov	eax,[buf+9]
	mov	[Deltaz],eax
	cmp	edx,eax
	jae	.b2
	mov	edx,eax			;b speichere in edx das größere Maß
	mov	ebx,Linez			;b und in ebx den zugehörigen Zeiger
	mov	ebp,Deltaz			;b und in ebp den vergleichs Zeiger
.b2:
	cmp	edx,0
	jz	.ende
	mov	ecx,0				;b ecx wird in brechner gesetzt
	mov	byte[statusB],cl		;b statusB zuruecksetzen
.c:
	call	brechner			;b setzt Delay
	call	linie
	call	outnc
	mov	eax,[ebx]			;b Ende berechnen eax = Line_
	mov	cl,[statusB]			;b neue Stufe in ecx
	add	eax,ecx			;b zum addieren
	cmp	eax,[ebp]			;b kann bis Ende gebremst werden ebp = Länge
	jnz	.c5				;b
	or	byte[statusB],10000000b	;b remsen
.c5:						;b
	mov	eax,[Deltax]
	cmp	eax,[Linex]
	jnz	.c
	mov	eax,[Deltay]
	cmp	eax,[Liney]
	jnz	.c
	mov	eax,[Deltaz]
	cmp	eax,[Linez]
	jnz	.c
.ende:
	mov	al,[buf+13]
	ret


