;Adobe Helvetica normal
;-------------------------------------------------
;	Code for the best assembler: The Netwide Assembler: NASM
;	Copyright (C) 2004 by Sebastian Beck; sebastian.bw@freenet.de

;	Wenn Sie eine Spende machen wollen, fragen Sie mich ber E-Mail
;	nach meiner Bankverbindung.

;	If you want to make a donation, please question me by e-mail for
;	my banking connection.

;-------------------------------------------------
;Fuert die Befehle in der Datei mit der Nummer datnum aus.
;-------------------------------------------------
;-------------------------------------------------
;Executes the instructions of the file with the number datnum.
;-------------------------------------------------

;%include "./INC/verteiler.inc"

;%include "./INC/LINIE.inc"
;%include "./INC/LINIEX.inc"
;%include "./INC/LINIEY.inc"
;%include "./INC/LINIEZ.inc"
;%include "./INC/KREIS.inc"
;%include "./INC/ELLIPSE.inc"
;%include "./INC/WARTE.inc"
;%include "./INC/STEUERUNG.inc"
;%include "./INC/SPIEL.inc"
;%include "./INC/KREISFUNKTION.inc"
;%include "./INC/ELLIPSENFUNKTION.inc"
;%include "./INC/SCHLEIFE.inc"
;%include "./INC/DELTAKREIS.inc"
;%include "./INC/DELTAELLIPS.inc"
;%include "./INC/VORSCHUB.inc"
;%include "./INC/DELTALINEAR.inc"
;%include "./INC/WERKZEUGWECHSEL.inc"
;%include "./INC/MEMO.inc"
;%include "./INC/BESCHLEUNIGUNG.inc"
;%include "./INC/WRP.inc"
;%include "./INC/SCHLEIFENSATZ.inc"
;%include "./INC/SPRINGE.inc"

;buf		resb	25		;Puffer fuer die Befehlskette aus der Datei
;datnum		dd	0

;-------------------------------------------------


verteiler:
section .text

	mov	eax,3
	mov	ebx,[datnum]
	mov	ecx,buf
	mov	edx,1
	int	80h
	cmp	eax,1
	jz	.a
	call	error1
	jmp	Ende
.a:
	mov	eax,0
	mov	al,[buf]
.b:
	call	writexyz

	cmp	al,0
	jnz	.b1
	call	nameout.ende
	jmp	Ende
.b1:
	cmp	al,1
	jnz	.b2
	call	LINIE
	call	nameout.linie
	jmp	.b
.b2:
	cmp	al,2
	jnz	.b3
	call	LINIEX
	call	nameout.liniex
	jmp	.b
.b3:
	cmp	al,3
	jnz	.b4
	call	LINIEY
	call	nameout.liniey
	jmp	.b
.b4:
	cmp	al,4
	jnz	.b5
	call	LINIEZ
	call	nameout.liniez
	jmp	.b
.b5:
	cmp	al,5
	jnz	.b6
	call	KREIS
	call	nameout.kreis
	jmp	.b
.b6:
	cmp	al,6
	jnz	.b7
	call	Ende
	jmp	.b
.b7:
	cmp	al,7
	jnz	.b8
	call	WARTE
	call	nameout.warte
	jmp	.b
.b8:
	cmp	al,8
	jnz	.b9
	call	STEUERUNG
	call	nameout.steuerung
	jmp	.b
.b9:
	cmp	al,9
	jnz	.b10
	call	SPIEL
	call	nameout.spiel
	jmp	.b
.b10:
	cmp	al,10
	jnz	.b11
	call	Ende
	jmp	.b
.b11:
	cmp	al,11
	jnz	.b12
	call	Ende
	jmp	.b
.b12:
	cmp	al,12
	jnz	.b13
	call	SCHLEIFE
	call	nameout.schleife
	jmp	.b
.b13:
	cmp	al,13
	jnz	.b14
	call	Ende
	jmp	.b
.b14:
	cmp	al,14
	jnz	.b15
	call	Ende
	jmp	.b
.b15:
	cmp	al,15
	jnz	.b16
	call	VORSCHUB
	call	nameout.vorschub
	jmp	.b
.b16:
	cmp	al,16
	jnz	.b17
	call	Ende
	jmp	.b
.b17:
	cmp	al,17
	jnz	.b18
	call	WERKZEUGWECHSEL
	call	nameout.werkzeugwechsel
	jmp	.b
.b18:
	cmp	al,18
	jnz	.b19
	call	MEMO
	call	nameout.memo
	jmp	.b
.b19:
	cmp	al,19
	jnz	.b20
	call	nameout.beschleunigung
	call	BESCHLEUNIGUNG
	jmp	.b
.b20:
	cmp	al,20
	jnz	.b21
	call	WRP
	call	nameout.wrp
	jmp	.b
.b21:
	cmp	al,21
	jnz	.b22
	call	SCHLEIFENSATZ
	call	nameout.schleifensatz
	jmp	.b
.b22:
	cmp	al,22
	jnz	.b23
	call	SPRINGE
	call	nameout.springe
	jmp	.b
.b23:

Ende:
	call	writexyz
	ret